VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSplitter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'See Spliiter.RECTLayouts for ASCII diagram of layouts.

'Internal variables.
Private Host As PictureBox
Private Rectangles() As LocalRECT
Private Const BORDEROFFSET = 90
Private Const TWIPOFFSET = 15

Private Type LocalRECT
    Top As Integer
    Left As Integer
    Width As Integer
    Height As Integer
    Right As Integer
    Bottom As Integer
End Type

'Exposed events.
Public Event Error(Message As String)

'Exposed properties.
Public Layout As Integer
Public HorizontalWidth As Integer
Public VerticalHeight As Integer

Public Sub DisplayRECTs()
    Host.Cls
    Select Case Layout
        Case 1
            'Rectangle 0 is the top half of the host.
            Host.Line (Rectangles(0).Left, Rectangles(0).Top)-(Rectangles(0).Right, Rectangles(0).Bottom), RGB(255, 0, 0), B
            
            'Rectangle 1 is the bottom half of the host.
            Host.Line (Rectangles(1).Left, Rectangles(1).Top)-(Rectangles(1).Right, Rectangles(1).Bottom), RGB(0, 255, 0), B
        Case 2
            'Rectangle 0 is the top part of the host.
            Host.Line (Rectangles(0).Left, Rectangles(0).Top)-(Rectangles(0).Right, Rectangles(0).Bottom), RGB(255, 0, 0), B
            
            'Rectangle 1 is the middle part of the host.
            Host.Line (Rectangles(1).Left, Rectangles(1).Top)-(Rectangles(1).Right, Rectangles(1).Bottom), RGB(0, 255, 0), B
            
            'Rectangle 2 is the bottom part of the host.
            Host.Line (Rectangles(2).Left, Rectangles(2).Top)-(Rectangles(2).Right, Rectangles(2).Bottom), RGB(255, 0, 255), B
        Case 3
            'Rectangle 0 is the top part of the host.
            Host.Line (Rectangles(0).Left, Rectangles(0).Top)-(Rectangles(0).Right, Rectangles(0).Bottom), RGB(255, 0, 0), B
            
            'Rectangle 1 is the left bottom part of the host.
            Host.Line (Rectangles(1).Left, Rectangles(1).Top)-(Rectangles(1).Right, Rectangles(1).Bottom), RGB(0, 255, 0), B
            
            'Rectangle 2 is the right bottom part of the host.
            Host.Line (Rectangles(2).Left, Rectangles(2).Top)-(Rectangles(2).Right, Rectangles(2).Bottom), RGB(255, 0, 255), B
        Case 4
            'Rectangle 0 is the top part of the host.
            Host.Line (Rectangles(0).Left, Rectangles(0).Top)-(Rectangles(0).Right, Rectangles(0).Bottom), RGB(255, 0, 0), B
            
            'Rectangle 1 is the left middle part of the host.
            Host.Line (Rectangles(1).Left, Rectangles(1).Top)-(Rectangles(1).Right, Rectangles(1).Bottom), RGB(0, 255, 0), B
            
            'Rectangle 2 is the right middle part of the host.
            Host.Line (Rectangles(2).Left, Rectangles(2).Top)-(Rectangles(2).Right, Rectangles(2).Bottom), RGB(255, 0, 255), B

            'Rectangle 3 is the bottom part of the host.
            Host.Line (Rectangles(3).Left, Rectangles(3).Top)-(Rectangles(3).Right, Rectangles(3).Bottom), RGB(255, 255, 0), B
    End Select
End Sub

Public Sub Initialize()
    If Layout > 0 Then
        ReDim Rectangles(Layout)
    Else
        RaiseEvent Error("layout not set?")
    End If
End Sub

Public Sub UpdateRECTs(Index As Integer, Value As Integer)
    'Set the rectangles state based upon layout and a value.
    Select Case Layout
        Case 1
            Select Case Index
                Case 0
                    'The one and only splitter in this layout.
                    Rectangles(0).Top = 0
                    Rectangles(0).Left = 0
                    Rectangles(0).Width = Host.Width - BORDEROFFSET
                    Rectangles(0).Height = Value
                    Rectangles(0).Bottom = Rectangles(0).Top + Rectangles(0).Height
                    Rectangles(0).Right = Rectangles(0).Left + Rectangles(0).Width
                    
                    Rectangles(1).Top = Value + VerticalHeight + TWIPOFFSET
                    Rectangles(1).Left = 0
                    Rectangles(1).Width = Host.Width - BORDEROFFSET
                    Rectangles(1).Height = Host.Height - Rectangles(1).Top - BORDEROFFSET
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    Rectangles(1).Right = Rectangles(1).Left + Rectangles(1).Width
            End Select
        Case 2
            Select Case Index
                Case 0
                    'Populate the top and middle rectangles.
                    Rectangles(0).Top = 0
                    Rectangles(0).Left = 0
                    Rectangles(0).Width = Host.Width - BORDEROFFSET
                    Rectangles(0).Height = Value
                    Rectangles(0).Bottom = Rectangles(0).Top + Rectangles(0).Height
                    Rectangles(0).Right = Rectangles(0).Left + Rectangles(0).Width
                    
                    Rectangles(1).Top = Value + VerticalHeight + TWIPOFFSET
                    Rectangles(1).Left = 0
                    Rectangles(1).Width = Host.Width - BORDEROFFSET
                    Rectangles(1).Height = Host.Height - Rectangles(1).Top
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    Rectangles(1).Right = Rectangles(1).Left + Rectangles(1).Width
                Case 1
                    'Populate the middle and bottom rectangles.
                    Rectangles(1).Height = Value - Rectangles(1).Top
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    
                    Rectangles(2).Top = Rectangles(1).Bottom + VerticalHeight + TWIPOFFSET
                    Rectangles(2).Left = 0
                    Rectangles(2).Width = Host.Width - BORDEROFFSET
                    Rectangles(2).Height = Host.Height - Rectangles(2).Top - BORDEROFFSET
                    Rectangles(2).Bottom = Rectangles(2).Top + Rectangles(2).Height
                    Rectangles(2).Right = Rectangles(2).Left + Rectangles(2).Width
            End Select

        Case 3
            Select Case Index
                Case 0
                    'Populate the top rectangle.
                    Rectangles(0).Top = 0
                    Rectangles(0).Left = 0
                    Rectangles(0).Width = Host.Width - BORDEROFFSET
                    Rectangles(0).Height = Value
                    Rectangles(0).Bottom = Rectangles(0).Top + Rectangles(0).Height
                    Rectangles(0).Right = Rectangles(0).Left + Rectangles(0).Width
                Case 1
                    'Populate the bottom left & right side.
                    Rectangles(1).Top = Rectangles(0).Height + VerticalHeight + TWIPOFFSET
                    Rectangles(1).Left = 0
                    Rectangles(1).Width = Value
                    Rectangles(1).Height = Host.Height - Rectangles(1).Top - BORDEROFFSET
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    Rectangles(1).Right = Rectangles(1).Left + Rectangles(1).Width
                    
                    Rectangles(2).Top = Rectangles(1).Top
                    Rectangles(2).Left = Value + VerticalHeight
                    Rectangles(2).Width = Host.Width - Value - BORDEROFFSET - VerticalHeight
                    Rectangles(2).Height = Rectangles(1).Height
                    Rectangles(2).Bottom = Rectangles(2).Top + Rectangles(2).Height
                    Rectangles(2).Right = Rectangles(2).Left + Rectangles(2).Width
            End Select
        Case 4
            Select Case Index
                Case 0
                    'Populate the top rectangle.
                    Rectangles(0).Top = 0
                    Rectangles(0).Left = 0
                    Rectangles(0).Width = Host.Width - BORDEROFFSET
                    Rectangles(0).Height = Value
                    Rectangles(0).Bottom = Rectangles(0).Top + Rectangles(0).Height
                    Rectangles(0).Right = Rectangles(0).Left + Rectangles(0).Width
                Case 1
                    'Populate the middle left & right side.
                    Rectangles(1).Top = Rectangles(0).Height + VerticalHeight + TWIPOFFSET
                    Rectangles(1).Left = 0
                    Rectangles(1).Width = Value
                    Rectangles(1).Height = Host.Height - Rectangles(1).Top - BORDEROFFSET
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    Rectangles(1).Right = Rectangles(1).Left + Rectangles(1).Width
                    
                    Rectangles(2).Top = Rectangles(1).Top
                    Rectangles(2).Left = Value + VerticalHeight
                    Rectangles(2).Width = Host.Width - Value - BORDEROFFSET - VerticalHeight
                    Rectangles(2).Height = Rectangles(1).Height
                    Rectangles(2).Bottom = Rectangles(2).Top + Rectangles(2).Height
                    Rectangles(2).Right = Rectangles(2).Left + Rectangles(2).Width
                Case 2
                    'Populate the bottom rectangle.
                    Rectangles(3).Top = Value + VerticalHeight
                    Rectangles(3).Left = 0
                    Rectangles(3).Width = Host.Width - BORDEROFFSET
                    Rectangles(3).Height = Host.Height - Rectangles(3).Top - BORDEROFFSET
                    Rectangles(3).Bottom = Rectangles(3).Top + Rectangles(3).Height
                    Rectangles(3).Right = Rectangles(3).Left + Rectangles(3).Width
                    
                    Rectangles(1).Height = Value - Rectangles(1).Top
                    Rectangles(1).Bottom = Rectangles(1).Top + Rectangles(1).Height
                    Rectangles(2).Height = Rectangles(1).Height
                    Rectangles(2).Bottom = Rectangles(2).Top + Rectangles(2).Height
            End Select
    End Select
End Sub

Public Sub RECTLayouts()
    'I'll try to document the layouts here using my ASCII art skills (ha-ha).
    '= symbolizes horzontal spliter.
    '! symbolizes vertical splitter.
    Select Case Layout
        Case 1
            'Horizontal divides host in two.
            '+----------------------------------------+
            '|
            '|
            '|
            '|=========================================
            '|
            '|
            '|
            '+----------------------------------------+

        Case 2
            'Horizontal divides host into three panels.
            '+----------------------------------------+
            '|
            '|=========================================
            '|
            '|
            '|
            '|=========================================
            '|
            '+----------------------------------------+

        Case 3
            'Divides host into three panels.
            '+----------------------------------------+
            '|
            '|==========================+==============
            '|                          !
            '|                          !
            '|                          !
            '|                          !
            '|                          !
            '+--------------------------+-------------+

        Case 4
            'Divides host into four panels.
            '+----------------------------------------+
            '|
            '|==========================+==============
            '|                          !
            '|                          !
            '|                          !
            '|==========================+==============
            '|
            '+--------------------------+-------------+

    End Select
End Sub
Private Sub Class_Initialize()
    Set Host = Form1.picHost
End Sub
Private Sub Class_Terminate()
    Set Host = Nothing
End Sub


